#ifndef __DEBUG_H
#define __DEBUG_H

/*#undef g_strdup_vprintf
#undef gnome_config_get_string
#undef g_malloc
#undef g_malloc0
#undef g_free
#undef strdup
#undef g_strdup

#define g_strdup_vprintf(x,y) debug_strdup_vprintf(x,y,__FILE__,__LINE__)

#define gnome_config_get_string(x) debug_gnome_config_get_string(x,__FILE__,__LINE__)

#define g_malloc(x) debug_malloc(x,__FILE__,__LINE__)
#define g_malloc0(x) debug_malloc0(x,__FILE__,__LINE__)

#define g_free(x) debug_free(x,__FILE__,__LINE__)

#define strdup(x) debug_strdup(x,__FILE__,__LINE__)
#define g_strdup(x) debug_strdup(x,__FILE__,__LINE__)*/


void d_warning(const char *, int, char *, char *, void *);
void *d_memory_hunk_append(const char *, int, void *, unsigned int);
char *d_config_get_string(const char *, int, const char *);
void *d_hunk_add(const char *, int, void *, unsigned int);
void *d_malloc(const char *, int, unsigned int);
void *d_calloc(const char *, int, unsigned int);
char *d_strdup_vprintf(const char *, int, const char *s, va_list args);
char *d_strdup_printf(const char *, int, const char *s, ...);
void *d_free(const char *, int, void *ptr);
char *d_strdup(const char *, int, const char *s);
void d_summary();

#define DEBUG __FILE__,__LINE__, 

#define d_config_get_string(x) d_config_get_string(DEBUG x)
#define d_hunk_add(x,y) d_hunk_add(DEBUG x,y)
#define d_malloc(x) d_malloc(DEBUG x)
#define d_calloc(x) d_calloc(DEBUG x)
#define d_strdup_vprintf(x,y) d_strdup_vprintf(DEBUG x,y)
//#define d_strdup_printf(x) d_strdup_printf(x,__FILE__,__LINE__)
#define d_free(x) d_free(DEBUG x)
#define d_strdup(x) d_strdup(DEBUG x)

#endif /* __DEBUG_H */
